import time
import math

from lib.controller import *
from datetime import datetime
from fischertechnik.mqtt.Client import Client as MqttClient
from fischertechnik.mqtt.Constants import CONTROLLER_ID
from numbers import Number


ts = None
alph = None
ldr = None


def timestamp():
    global ts, alph, ldr
    ts = datetime.utcnow().strftime("%Y-%m-%dT%H:%M:%S.%f")[:-3] + "Z"
    return ts


MqttClient.getInstance().connect()
time.sleep(1)
if MqttClient.getInstance().is_connected():
    print('Connected to fischertechnik-cloud')
    alph = 0
    for count in range(100):
        ldr = 10 * math.sin(alph / 180.0 * math.pi)
        MqttClient.getInstance().publish("/j1/txt/" + str(CONTROLLER_ID) +"/i/ldr", '{{"ts":"{}", "br":{}}}'.format(timestamp(), ldr))
        print('Sent {} to fischertechnik-cloud'.format(round(ldr, 2)))
        alph = (alph if isinstance(alph, Number) else 0) + 30
        time.sleep(15)
    MqttClient.getInstance().disconnect()
    print('Disconnected from fischertechnik-cloud')
else:
    print('Connection to fischertechnik-cloud failed')
